bftsmart.tom.server

## Interface SingleExecutable

All Superinterfaces:
  Executable

All Known Subinterfaces:
  FIFOExecutable

All Known Implementing Classes:
  DefaultSingleRecoverable

    public interface SingleExecutable
    extends Executable

Executables that implement this interface will receive client requests individually.

### Method Summary

All Methods Instance Methods Abstract Methods
`byte[]` `executeOrdered(byte[] command, MessageContext msgCtx)` Method called to execute a request totally ordered.

### Methods inherited from interface bftsmart.tom.server.Executable

`executeUnordered`

### Method Detail

#### executeOrdered

    byte[] executeOrdered(byte[] command,
                          MessageContext msgCtx)

Method called to execute a request totally ordered. The message context contains a lot of information about the request, such as timestamp, nonces and sender. The code for this method MUST use the value of timestamp instead of relying on its own local clock, and nonces instead of trying to generated its own random values. This is important because this values are the same for all replicas, and therefore, ensure the determinism required in a replicated state machine.

Parameters:
  `command` - the command issue by the client
  `msgCtx` - information related with the command
Returns:
  the reply for the request issued by the client